/******************************************************************************
 *   Copyright (C) 2006 by Igor Timoshenko  (timigor@yandex.ru).              *
 *  Use may be in whole or in part in accordance to the                       *
 *  General Public License (GPL).                                             *
 *   Simple net driver                                                        *
 ******************************************************************************/
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/netdevice.h>
#include <linux/skbuff.h>
/*  IP */
struct iphdr  {
    unsigned int ihl:4;
    unsigned int version:4;
    u_int8_t tos;
    u_int16_t tot_len;
    u_int16_t id;
    u_int16_t frag_off;
    u_int8_t ttl;
    u_int8_t protocol;
    u_int16_t check;
    unsigned char saddr[4]; /* IP address of originator */
    unsigned char daddr[4]; /* IP address of destination */
    /*The options start here. */
  };
/*   */
struct my_buf {
int tlen;
	union tbuffer{
	unsigned char tail[2];	/* */
	unsigned char tbuff[1024];
	struct iphdr thdr;
	}tb;
};
struct net_device_stats *stats;
struct my_buf xbf;
int retval, shift, i;

int ssl_stop (struct net_device *dev);
int ssl_open (struct net_device *dev);
static int ssl_xmit(struct sk_buff *skb, struct net_device *dev);
void tpdumpk(struct my_buf *xbf);
/*  */  
struct net_device ssl_dev = {
	.name			= "ssl",
	.open			= ssl_open,
	.stop			= ssl_stop,
	.hard_start_xmit	= ssl_xmit,
};
static struct net_device_stats *ssl_get_stats(struct net_device *dev)
{ return dev->priv; }
/* ######################################################*/
static int ssl_xmit (struct sk_buff *skb, struct net_device *dev)
{
struct my_buf *qbf = &xbf;
	if (skb->len > 1024 - 3) {
	printk(KERN_WARNING "ssl: T_buffer is small, dropping packet.\n");
	stats->tx_dropped++;
	} else {
		/*    */
		xbf.tlen = skb->len;
		shift = 0;
			while (shift + 1 <= skb->len) {
			xbf.tb.tbuff[shift] = skb->data[shift];
			shift++;
			}
		qbf->tlen = skb->len;
		stats->tx_bytes += skb->len;
		stats->tx_packets++;
	tpdumpk(&xbf);   /*   */
	dev_kfree_skb(skb);
	stats->tx_bytes += skb->len;
	stats->tx_packets++;
	}
return 0;
}
/*  ###########################*/
int ssl_open (struct net_device *dev)
{
printk(KERN_WARNING "ssl: ssl_open called.\n");
netif_start_queue (dev);
return 0;
}
/*  #############################*/
int ssl_stop (struct net_device *dev)
{
printk (KERN_WARNING "ssl: ssl_stop called.\n");
netif_stop_queue(dev);
	return 0;
}
/*============= ===============*/
int ssl_init_module (void)
{
stats = kmalloc(sizeof(struct net_device_stats), GFP_KERNEL);
	if (stats) {
	memset(stats, 0, sizeof(struct net_device_stats));
	ssl_dev.priv = stats;
	ssl_dev.get_stats = &ssl_get_stats;
	}
	if ((retval = register_netdev (&ssl_dev))) {
	printk (KERN_WARNING "ssl: Error %d  of initializing module.\n",retval);
	return retval;
	}
printk(KERN_WARNING "ssl: initializing the module.\n");
return 0;
}
/*============ =======================*/
void ssl_cleanup (void)
{
unregister_netdev (&ssl_dev);
printk (KERN_WARNING "ssl: Cleaning Up the Module.\n");
return;
}
module_init (ssl_init_module);
module_exit (ssl_cleanup);
/*  ###################################### */
/*       .*/
void printAddr(unsigned char *addr)
{
int j;
	for ( j = 0; j < 4; j++ )
	{
	printk("%d", addr[j]);
	if ( j < 3 )
		printk(".");
	}
}
/*   */
void tpdumpk(struct my_buf *txbf)
{
int i;
	printk("\n---RETURNING---");
	for ( i = 0; i < txbf->tlen; i++ )
	{
		if ( !(i & 15) ) printk("\n%04X:  ", i);
		printk("%02X ", ((unsigned char*)txbf->tb.tbuff)[i]);
	}
	printk("\n");
	printk("IPv%d: hdr-size=%d pkt-size=%d protocol=%d TTL=%d ",
		txbf->tb.thdr.version, txbf->tb.thdr.ihl*4, ntohs(txbf->tb.thdr.tot_len),
		txbf->tb.thdr.protocol, txbf->tb.thdr.ttl);
printk("\n");
	printk("rst= ");
printAddr(txbf->tb.thdr.saddr);
	printk(" dst= ");
printAddr(txbf->tb.thdr.daddr);
printk("\n");
}
